"use strict";

var path = require('path');
var through2 = require('through2');

module.exports = function (file, options) {
    options = options || {};
    var isJSXFile = path.extname(file) === '.jsx';
    var reactTransform;
    if (options.reactTools) {
        reactTransform = require(options.reactTools).transform;
    } else {
        reactTransform = require('react-tools').transform;
    }

    var data = '';

    function write(chunk, encoding, callback) {
        data += chunk;
        callback();
    }

    function compile(callback) {
        if (!isJSXFile) {
            isJSXFile = /\/\*\*(\s)@jsx/.test(data.split('\n')[0]);
        }
        if (isJSXFile) {
            try {
                var transformed = reactTransform(data, options.transformOptions || {});
                this.push(transformed);
                callback();
            } catch (error) {
                error.name = 'JsxError';
                error.message = file + ': ' + error.message;
                error.fileName = file;
                callback(error);
            }
        } else {
            this.push(data);
            callback();
            return;
        }
        callback();
    }

    return through2(write, compile);
};